//-----------------------------------------------------------------------------
// File: LudumDare.cpp
// Bennuk
//-----------------------------------------------------------------------------
#include <Windows.h>
#include <mmsystem.h>
#include <d3dx9.h>
#pragma warning( disable : 4996 ) // disable deprecated warning 
#include <strsafe.h>
#pragma warning( default : 4996 )

//-----------------------------------------------------------------------------
// Global variables
//-----------------------------------------------------------------------------
LPDIRECT3D9             g_pD3D = NULL; // Used to create the D3DDevice
LPDIRECT3DDEVICE9       g_pd3dDevice = NULL; // Our rendering device
LPDIRECT3DVERTEXBUFFER9 g_pVB = NULL; // Buffer to hold vertices
LPDIRECT3DTEXTURE9      g_pHudBackTexture = NULL;
LPDIRECT3DTEXTURE9      g_pMouseTexture = NULL;
LPDIRECT3DTEXTURE9      g_pGridTexture = NULL;
LPDIRECT3DTEXTURE9      g_pXTexture = NULL;
LPDIRECT3DTEXTURE9      g_pNumberTexture = NULL;
LPDIRECT3DTEXTURE9      g_pNewgameTexture = NULL;
LPDIRECT3DTEXTURE9      g_pExitgameTexture = NULL;
LPDIRECT3DTEXTURE9      g_pFailureTexture = NULL;
LPDIRECT3DTEXTURE9      g_pRetryTexture = NULL;
LPDIRECT3DTEXTURE9      g_pMenuTexture = NULL;
LPDIRECT3DTEXTURE9      g_pContinueTexture = NULL;
LPDIRECT3DTEXTURE9      g_pVictoryTexture = NULL;
LPDIRECT3DTEXTURE9      g_pNextTexture = NULL;
LPDIRECT3DTEXTURE9      g_pGrateTexture = NULL;
LPDIRECT3DTEXTURE9      g_pDudeTexture = NULL;
LPDIRECT3DTEXTURE9      g_pWaterTexture = NULL;
LPDIRECT3DTEXTURE9      g_pLandTexture = NULL;
LPDIRECT3DTEXTURE9      g_pCrateTexture = NULL;
LPDIRECT3DTEXTURE9      g_pResetTexture = NULL;
LPDIRECT3DTEXTURE9      g_pLaunchTexture = NULL;
LPDIRECT3DTEXTURE9      g_pAdvice1Texture = NULL;
LPDIRECT3DTEXTURE9      g_pAdvice2Texture = NULL;
LPDIRECT3DTEXTURE9      g_pAdvice3Texture = NULL;
LPDIRECT3DTEXTURE9      g_pTitleTexture = NULL;
LPDIRECT3DTEXTURE9      g_pEndgameTexture = NULL;
LPD3DXSPRITE            g_pGridSprite  = NULL;


float  g_fElpasedTime;
double g_dCurTime;
double g_dLastTime;

bool GameWaterRunning = false;
int GameLandBlocks[7] = { 2,1,3,1,1,4,2 }; 
int GameCurrentBlocks = 0;
int GameCurrentLevel = 0;
bool GameInMenu = true;
bool GameHasLost = false;
bool GameHasWon = false;
bool GameInTutorial = false;

POINT ptCurrentMousePosit;
int mousex, mousey;

/*

0 - Sea Bed
1 - Land
2 - Water
3 - DO NOT USE - used by code to spread water
4 - Person
5 - Grate
6 - Occupied Grate
7 - Crate

*/

int MyArray[15][20];

int Level1[15][20] = 
{

	{ 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1 },
	{ 1,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1 },
	{ 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1 },
	{ 1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,0,1 },
	{ 1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,0,1 },
	{ 1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,0,1 },
	{ 1,0,0,0,0,0,0,0,0,0,0,1,0,0,4,0,0,1,0,1 },
	{ 1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,0,1 },
	{ 1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,0,1 },
	{ 1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,1,1,1,0,1 },
	{ 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1 },
	{ 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1 },
	{ 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1 },
	{ 1,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1 },
	{ 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1 },

};


int Level2[15][20] = 
{

	{ 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1 },
	{ 1,2,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1 },
	{ 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1 },
	{ 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1 },
	{ 1,0,0,0,0,0,0,0,1,1,0,0,1,1,0,0,0,1,0,1 },
	{ 1,0,0,0,0,0,0,0,1,1,0,0,1,1,0,0,0,1,0,1 },
	{ 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1 },
	{ 1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,1,0,1 },
	{ 1,0,0,0,0,0,0,1,0,0,0,0,0,0,1,0,0,1,0,1 },
	{ 1,0,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,1,0,1 },
	{ 1,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,1,0,1 },
	{ 1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,2,1,0,1 },
	{ 1,1,1,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1 },
	{ 1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1 },
	{ 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1 },

};

int Level3[15][20] = 
{

	{ 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1 },
	{ 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,1 },
	{ 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1 },
	{ 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1 },
	{ 1,0,0,1,1,1,1,1,1,1,7,1,1,1,7,1,1,1,1,1 },
	{ 1,0,0,0,0,1,1,1,1,1,0,1,1,1,0,1,1,1,1,1 },
	{ 1,0,0,0,0,1,1,1,1,1,0,1,1,1,0,1,1,1,1,1 },
	{ 1,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,1 },
	{ 1,0,0,0,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1 },
	{ 1,0,0,0,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1 },
	{ 1,0,0,1,1,1,1,1,1,1,1,1,7,1,1,1,1,1,1,1 },
	{ 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1 },
	{ 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1 },
	{ 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,1 },
	{ 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1 },

};

int Level4[15][20] = 
{

	{ 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1 },
	{ 1,2,0,0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,2,1 },
	{ 1,0,1,1,1,1,1,1,0,0,0,0,1,0,1,0,0,0,0,1 },
	{ 1,0,1,0,0,0,0,0,0,1,1,1,1,0,1,0,0,0,0,1 },
	{ 1,0,1,1,1,1,1,1,0,1,2,1,1,0,1,1,1,1,1,1 },
	{ 1,0,0,0,0,0,0,0,0,1,0,0,0,7,0,0,0,2,1,1 },
	{ 1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1 },
	{ 1,2,4,0,0,0,0,0,0,0,0,0,0,0,1,2,0,0,0,1 },
	{ 1,1,1,1,1,1,1,1,1,1,1,1,0,4,1,0,0,0,0,1 },
	{ 1,2,0,0,0,0,0,0,0,0,0,1,0,0,1,1,1,1,0,1 },
	{ 1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,5,1,0,1 },
	{ 1,0,0,0,0,0,0,0,0,0,0,1,5,1,1,1,1,1,0,1 },
	{ 1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1 },
	{ 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1 },
	{ 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1 },

};

int Level5[15][20] = 
{

	{ 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1 },
	{ 1,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,1 },
	{ 1,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,1 },
	{ 1,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,1 },
	{ 1,0,0,0,0,0,1,1,1,7,1,1,1,0,0,0,0,0,0,1 },
	{ 1,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,0,0,0,1 },
	{ 1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1 },
	{ 1,2,0,0,0,0,7,0,0,4,0,0,7,0,0,0,0,0,2,1 },
	{ 1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1 },
	{ 1,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,0,0,0,1 },
	{ 1,0,0,0,0,0,1,1,1,7,1,1,1,0,0,0,0,0,0,1 },
	{ 1,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,1 },
	{ 1,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,1 },
	{ 1,0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0,0,0,1 },
	{ 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1 },

};

int Level6[15][20] = 
{

	{ 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1 },
	{ 1,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,1 },
	{ 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1 },
	{ 1,0,0,1,1,1,1,1,1,0,0,1,7,0,0,0,0,0,0,1 },
	{ 1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1 },
	{ 1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1 },
	{ 1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1 },
	{ 1,0,0,0,0,0,0,1,0,4,0,1,0,0,0,0,0,0,0,1 },
	{ 1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1 },
	{ 1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1 },
	{ 1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1 },
	{ 1,0,0,0,0,0,7,1,0,0,0,1,1,1,1,1,1,0,0,1 },
	{ 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1 },
	{ 1,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,1 },
	{ 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1 },

};

int Level7[15][20] = 
{

	{ 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1 },
	{ 1,1,2,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,2,1 },
	{ 1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1 },
	{ 1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1 },
	{ 1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1 },
	{ 1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1 },
	{ 1,1,1,0,1,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1 },
	{ 1,5,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1 },
	{ 1,1,1,0,1,0,1,0,1,0,0,0,0,0,0,0,0,0,0,1 },
	{ 1,5,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,1 },
	{ 1,1,1,0,1,0,1,0,1,0,0,0,0,0,0,0,0,0,0,1 },
	{ 1,5,0,4,0,0,0,4,0,0,0,0,0,0,0,0,0,0,2,1 },
	{ 1,1,1,0,1,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1 },
	{ 1,0,1,5,1,5,1,5,1,1,1,1,1,1,1,1,1,1,1,1 },
	{ 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1 },

};

// A structure for our custom vertex type
struct CUSTOMVERTEX
{
    FLOAT x, y, z;      // The untransformed, 3D position for the vertex
    DWORD color;        // The vertex color
};

// Our custom FVF, which describes our custom vertex structure
#define D3DFVF_CUSTOMVERTEX (D3DFVF_XYZ|D3DFVF_DIFFUSE)


void loadTexture( void )
{
	D3DXIMAGE_INFO d3dxImageInfo;

	D3DXCreateTextureFromFileEx( g_pd3dDevice,
                                 "grid.bmp",
                                 32, 
                                 32, 
                                 1,   
                                 D3DPOOL_DEFAULT,
                                 D3DFMT_UNKNOWN,
                                 D3DPOOL_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DCOLOR_COLORVALUE(0.0f,0.0f,0.0f,1.0f),
                                 &d3dxImageInfo,
                                 NULL,
                                 &g_pGridTexture );

	D3DXCreateTextureFromFileEx( g_pd3dDevice,
                                 "mouseover.bmp",
                                 32, 
                                 32, 
                                 1,   
                                 D3DPOOL_DEFAULT,
                                 D3DFMT_UNKNOWN,
                                 D3DPOOL_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DCOLOR_COLORVALUE(0.0f,0.0f,0.0f,1.0f),
                                 &d3dxImageInfo,
                                 NULL,
                                 &g_pMouseTexture );

	D3DXCreateTextureFromFileEx( g_pd3dDevice,
                                 "hudbackdrop.bmp",
                                 640, 
                                 64, 
                                 1,   
                                 D3DPOOL_DEFAULT,
                                 D3DFMT_UNKNOWN,
                                 D3DPOOL_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DCOLOR_COLORVALUE(0.0f,0.0f,0.0f,1.0f),
                                 &d3dxImageInfo,
                                 NULL,
                                 &g_pHudBackTexture );

	D3DXCreateTextureFromFileEx( g_pd3dDevice,
                                 "x.bmp",
                                 16, 
                                 16, 
                                 1,   
                                 D3DPOOL_DEFAULT,
                                 D3DFMT_UNKNOWN,
                                 D3DPOOL_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DCOLOR_COLORVALUE(0.0f,0.0f,0.0f,1.0f),
                                 &d3dxImageInfo,
                                 NULL,
                                 &g_pXTexture );

	D3DXCreateTextureFromFileEx( g_pd3dDevice,
                                 "numbers.bmp",
                                 320, 
                                 32, 
                                 1,   
                                 D3DPOOL_DEFAULT,
                                 D3DFMT_UNKNOWN,
                                 D3DPOOL_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DCOLOR_COLORVALUE(0.0f,0.0f,0.0f,1.0f),
                                 &d3dxImageInfo,
                                 NULL,
                                 &g_pNumberTexture );

	D3DXCreateTextureFromFileEx( g_pd3dDevice,
                                 "newgame.bmp",
                                 320, 
                                 64, 
                                 1,   
                                 D3DPOOL_DEFAULT,
                                 D3DFMT_UNKNOWN,
                                 D3DPOOL_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DCOLOR_COLORVALUE(0.0f,0.0f,0.0f,1.0f),
                                 &d3dxImageInfo,
                                 NULL,
                                 &g_pNewgameTexture );

	D3DXCreateTextureFromFileEx( g_pd3dDevice,
                                 "exit.bmp",
                                 320, 
                                 64, 
                                 1,   
                                 D3DPOOL_DEFAULT,
                                 D3DFMT_UNKNOWN,
                                 D3DPOOL_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DCOLOR_COLORVALUE(0.0f,0.0f,0.0f,1.0f),
                                 &d3dxImageInfo,
                                 NULL,
                                 &g_pExitgameTexture );

	D3DXCreateTextureFromFileEx( g_pd3dDevice,
                                 "failure.bmp",
                                 320, 
                                 64, 
                                 1,   
                                 D3DPOOL_DEFAULT,
                                 D3DFMT_UNKNOWN,
                                 D3DPOOL_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DCOLOR_COLORVALUE(0.0f,0.0f,0.0f,1.0f),
                                 &d3dxImageInfo,
                                 NULL,
                                 &g_pFailureTexture );

	D3DXCreateTextureFromFileEx( g_pd3dDevice,
                                 "retry.bmp",
                                 128, 
                                 32, 
                                 1,   
                                 D3DPOOL_DEFAULT,
                                 D3DFMT_UNKNOWN,
                                 D3DPOOL_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DCOLOR_COLORVALUE(0.0f,0.0f,0.0f,1.0f),
                                 &d3dxImageInfo,
                                 NULL,
                                 &g_pRetryTexture );

	D3DXCreateTextureFromFileEx( g_pd3dDevice,
                                 "menu.bmp",
                                 128, 
                                 50, 
                                 1,   
                                 D3DPOOL_DEFAULT,
                                 D3DFMT_UNKNOWN,
                                 D3DPOOL_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DCOLOR_COLORVALUE(0.0f,0.0f,0.0f,1.0f),
                                 &d3dxImageInfo,
                                 NULL,
                                 &g_pMenuTexture );

	D3DXCreateTextureFromFileEx( g_pd3dDevice,
                                 "continue.bmp",
                                 320, 
                                 64, 
                                 1,   
                                 D3DPOOL_DEFAULT,
                                 D3DFMT_UNKNOWN,
                                 D3DPOOL_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DCOLOR_COLORVALUE(0.0f,0.0f,0.0f,1.0f),
                                 &d3dxImageInfo,
                                 NULL,
                                 &g_pContinueTexture );

	D3DXCreateTextureFromFileEx( g_pd3dDevice,
                                 "victory.bmp",
                                 320, 
                                 64, 
                                 1,   
                                 D3DPOOL_DEFAULT,
                                 D3DFMT_UNKNOWN,
                                 D3DPOOL_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DCOLOR_COLORVALUE(0.0f,0.0f,0.0f,1.0f),
                                 &d3dxImageInfo,
                                 NULL,
                                 &g_pVictoryTexture );

		D3DXCreateTextureFromFileEx( g_pd3dDevice,
                                 "next.bmp",
                                 128, 
                                 32, 
                                 1,   
                                 D3DPOOL_DEFAULT,
                                 D3DFMT_UNKNOWN,
                                 D3DPOOL_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DCOLOR_COLORVALUE(0.0f,0.0f,0.0f,1.0f),
                                 &d3dxImageInfo,
                                 NULL,
                                 &g_pNextTexture );

		D3DXCreateTextureFromFileEx( g_pd3dDevice,
                                 "grate.bmp",
                                 32, 
                                 32, 
                                 1,   
                                 D3DPOOL_DEFAULT,
                                 D3DFMT_UNKNOWN,
                                 D3DPOOL_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DCOLOR_COLORVALUE(0.0f,0.0f,0.0f,1.0f),
                                 &d3dxImageInfo,
                                 NULL,
                                 &g_pGrateTexture );

		D3DXCreateTextureFromFileEx( g_pd3dDevice,
                                 "dude.bmp",
                                 32, 
                                 32, 
                                 1,   
                                 D3DPOOL_DEFAULT,
                                 D3DFMT_UNKNOWN,
                                 D3DPOOL_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DCOLOR_COLORVALUE(0.0f,0.0f,0.0f,1.0f),
                                 &d3dxImageInfo,
                                 NULL,
                                 &g_pDudeTexture );

		D3DXCreateTextureFromFileEx( g_pd3dDevice,
                                 "water.bmp",
                                 32, 
                                 32, 
                                 1,   
                                 D3DPOOL_DEFAULT,
                                 D3DFMT_UNKNOWN,
                                 D3DPOOL_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DCOLOR_COLORVALUE(0.0f,0.0f,0.0f,1.0f),
                                 &d3dxImageInfo,
                                 NULL,
                                 &g_pWaterTexture );

		D3DXCreateTextureFromFileEx( g_pd3dDevice,
                                 "land.bmp",
                                 32, 
                                 32, 
                                 1,   
                                 D3DPOOL_DEFAULT,
                                 D3DFMT_UNKNOWN,
                                 D3DPOOL_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DCOLOR_COLORVALUE(0.0f,0.0f,0.0f,1.0f),
                                 &d3dxImageInfo,
                                 NULL,
                                 &g_pLandTexture );

		D3DXCreateTextureFromFileEx( g_pd3dDevice,
                                 "crate.bmp",
                                 32, 
                                 32, 
                                 1,   
                                 D3DPOOL_DEFAULT,
                                 D3DFMT_UNKNOWN,
                                 D3DPOOL_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DCOLOR_COLORVALUE(0.0f,0.0f,0.0f,1.0f),
                                 &d3dxImageInfo,
                                 NULL,
                                 &g_pCrateTexture );

		D3DXCreateTextureFromFileEx( g_pd3dDevice,
                                 "reset.bmp",
                                 128, 
                                 32, 
                                 1,   
                                 D3DPOOL_DEFAULT,
                                 D3DFMT_UNKNOWN,
                                 D3DPOOL_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DCOLOR_COLORVALUE(0.0f,0.0f,0.0f,1.0f),
                                 &d3dxImageInfo,
                                 NULL,
                                 &g_pResetTexture );

		D3DXCreateTextureFromFileEx( g_pd3dDevice,
                                 "launch.bmp",
                                 128, 
                                 32, 
                                 1,   
                                 D3DPOOL_DEFAULT,
                                 D3DFMT_UNKNOWN,
                                 D3DPOOL_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DCOLOR_COLORVALUE(0.0f,0.0f,0.0f,1.0f),
                                 &d3dxImageInfo,
                                 NULL,
                                 &g_pLaunchTexture );

		D3DXCreateTextureFromFileEx( g_pd3dDevice,
                                 "advice.bmp",
                                 512, 
                                 352, 
                                 1,   
                                 D3DPOOL_DEFAULT,
                                 D3DFMT_UNKNOWN,
                                 D3DPOOL_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DCOLOR_COLORVALUE(0.0f,0.0f,0.0f,1.0f),
                                 &d3dxImageInfo,
                                 NULL,
                                 &g_pAdvice1Texture );

		D3DXCreateTextureFromFileEx( g_pd3dDevice,
                                 "advice2.bmp",
                                 512, 
                                 352, 
                                 1,   
                                 D3DPOOL_DEFAULT,
                                 D3DFMT_UNKNOWN,
                                 D3DPOOL_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DCOLOR_COLORVALUE(0.0f,0.0f,0.0f,1.0f),
                                 &d3dxImageInfo,
                                 NULL,
                                 &g_pAdvice2Texture );
		
		D3DXCreateTextureFromFileEx( g_pd3dDevice,
                                 "advice3.bmp",
                                 512, 
                                 352, 
                                 1,   
                                 D3DPOOL_DEFAULT,
                                 D3DFMT_UNKNOWN,
                                 D3DPOOL_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DCOLOR_COLORVALUE(0.0f,0.0f,0.0f,1.0f),
                                 &d3dxImageInfo,
                                 NULL,
                                 &g_pAdvice3Texture );

		D3DXCreateTextureFromFileEx( g_pd3dDevice,
                                 "title.bmp",
                                 620, 
                                 524, 
                                 1,   
                                 D3DPOOL_DEFAULT,
                                 D3DFMT_UNKNOWN,
                                 D3DPOOL_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DCOLOR_COLORVALUE(0.0f,0.0f,0.0f,1.0f),
                                 &d3dxImageInfo,
                                 NULL,
                                 &g_pTitleTexture );

		D3DXCreateTextureFromFileEx( g_pd3dDevice,
                                 "endgame.bmp",
                                 512, 
                                 352, 
                                 1,   
                                 D3DPOOL_DEFAULT,
                                 D3DFMT_UNKNOWN,
                                 D3DPOOL_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DX_DEFAULT,
                                 D3DCOLOR_COLORVALUE(0.0f,0.0f,0.0f,1.0f),
                                 &d3dxImageInfo,
                                 NULL,
                                 &g_pEndgameTexture );

    g_pd3dDevice->SetSamplerState(0, D3DSAMP_MINFILTER, D3DTEXF_LINEAR);
	g_pd3dDevice->SetSamplerState(0, D3DSAMP_MAGFILTER, D3DTEXF_LINEAR);
}

//-----------------------------------------------------------------------------
// Name: InitD3D()
// Desc: Initializes Direct3D
//-----------------------------------------------------------------------------
HRESULT InitD3D( HWND hWnd )
{
    // Create the D3D object.
    if( NULL == ( g_pD3D = Direct3DCreate9( D3D_SDK_VERSION ) ) )
        return E_FAIL;

    // Set up the structure used to create the D3DDevice
    D3DPRESENT_PARAMETERS d3dpp;
    ZeroMemory( &d3dpp, sizeof( d3dpp ) );
    d3dpp.Windowed = TRUE;
    d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
    d3dpp.BackBufferFormat = D3DFMT_UNKNOWN;

    // Create the D3DDevice
    if( FAILED( g_pD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd,
                                      D3DCREATE_SOFTWARE_VERTEXPROCESSING,
                                      &d3dpp, &g_pd3dDevice ) ) )
    {
        return E_FAIL;
    }

	loadTexture();

    // Turn off culling, so we see the front and back of the triangle
    g_pd3dDevice->SetRenderState( D3DRS_CULLMODE, D3DCULL_NONE );

    // Turn off D3D lighting, since we are providing our own vertex colors
    g_pd3dDevice->SetRenderState( D3DRS_LIGHTING, FALSE );

	D3DXCreateSprite( g_pd3dDevice, &g_pGridSprite );

    return S_OK;
}




//-----------------------------------------------------------------------------
// Name: InitGeometry()
// Desc: Creates the scene geometry
//-----------------------------------------------------------------------------
HRESULT InitGeometry()
{
    return S_OK;
}


//-----------------------------------------------------------------------------
// Name: Cleanup()
// Desc: Releases all previously initialized objects
//-----------------------------------------------------------------------------
VOID Cleanup()
{
    if( g_pVB != NULL )
        g_pVB->Release();

    if( g_pd3dDevice != NULL )
        g_pd3dDevice->Release();

    if( g_pD3D != NULL )
        g_pD3D->Release();

	if( g_pGridSprite != NULL ) 
        g_pGridSprite->Release();

	if( g_pGridTexture != NULL ) 
        g_pGridTexture->Release();

	if( g_pMouseTexture != NULL ) 
        g_pMouseTexture->Release();

	if( g_pHudBackTexture != NULL ) 
        g_pHudBackTexture->Release();
}

bool EscapeUp(int y, int x)
{

	if (MyArray[y-1][x] == 0)
	{

		MyArray[y-1][x] = 4;
		return true;

	}
	else if (MyArray[y-1][x] == 5)
	{

		MyArray[y-1][x] = 6;
		return true;

	}

	return false;

}

bool EscapeDown(int y, int x)
{

	if (MyArray[y+1][x] == 0)
	{

		MyArray[y+1][x] = 4;
		return true;

	}
	else if (MyArray[y+1][x] == 5)
	{

		MyArray[y+1][x] = 6;
		return true;

	}

	return false;

}

bool EscapeLeft(int y, int x)
{

	if (MyArray[y][x-1] == 0)
	{

		MyArray[y][x-1] = 4;
		return true;

	}
	else if (MyArray[y][x-1] == 5)
	{

		MyArray[y][x-1] = 6;
		return true;

	}

	return false;

}

bool EscapeRight(int y, int x)
{

	if (MyArray[y][x+1] == 0)
	{

		MyArray[y][x+1] = 4;
		return true;

	}
	else if (MyArray[y][x+1] == 5)
	{

		MyArray[y][x+1] = 6;
		return true;

	}

	return false;

}

void PersonTryEscape(int y, int x, int dir) //dir 1 - up, 2 - down, 3 - left, 4 - right - person should be trying to escape in this direction
{

	if (dir == 1)
	{
		if (EscapeUp(y,x) == false)
		{
			if (EscapeRight(y,x) == false)
			{
				if (EscapeLeft(y,x) == false)
				{
					GameWaterRunning = false;
					GameHasLost = true;
				}
			}
		}
	}
	else if (dir == 2)
	{
		if (EscapeDown(y,x) == false)
		{
			if (EscapeRight(y,x) == false)
			{
				if (EscapeLeft(y,x) == false)
				{
					GameWaterRunning = false;
					GameHasLost = true;
				}
			}
		}
	}
	else if (dir == 3)
	{
		if (EscapeLeft(y,x) == false)
		{
			if (EscapeDown(y,x) == false)
			{
				if (EscapeUp(y,x) == false)
				{
					GameWaterRunning = false;
					GameHasLost = true;
				}
			}
		}
	}
	else if (dir == 4)
	{
		if (EscapeRight(y,x) == false)
		{
			if (EscapeDown(y,x) == false)
			{
				if (EscapeUp(y,x) == false)
				{
					GameWaterRunning = false;
					GameHasLost = true;
				}
			}
		}
	}
	

	MyArray[y][x] = 0;

}

void TryPushCrate(int y, int x, int dir) //dir 1 - up, 2 - down, 3 - left, 4 - right
{

	if (dir == 1)
	{
		if (MyArray[y-1][x] == 0)
		{
			MyArray[y-1][x] = 7;
			MyArray[y][x] = 0;
		}
	}
	else if (dir == 2)
	{
		if (MyArray[y+1][x] == 0)
		{
			MyArray[y+1][x] = 7;
			MyArray[y][x] = 0;
		}
	}
	else if (dir == 3)
	{
		if (MyArray[y][x-1] == 0)
		{
			MyArray[y][x-1] = 7;
			MyArray[y][x] = 0;
		}
	}
	else if (dir == 4)
	{
		if (MyArray[y][x+1] == 0)
		{
			MyArray[y][x+1] = 7;
			MyArray[y][x] = 0;
		}

	}

}

void CheckMovement()
{

	bool WaterMoved = false;

	for (int y = 0; y < 15; ++y)
	{

		for (int x = 0; x < 20; ++x)
		{

			if (MyArray[y][x] == 2)
			{

				if (MyArray[y+1][x] == 7) //if crate below
				{
					TryPushCrate(y+1,x,2);
				}

				if (MyArray[y-1][x] == 7) //if crate above
				{
					TryPushCrate(y-1,x,1);
				}

				if (MyArray[y][x+1] == 7) //if crate to the right
				{
					TryPushCrate(y,x+1,4);
				}

				if (MyArray[y][x-1] == 7) //if crate to the left
				{
					TryPushCrate(y,x-1,3);
				}

				if (MyArray[y+1][x] == 4) //if person underneath
				{
					PersonTryEscape(y+1,x,2);
					WaterMoved = true;
				}

				if (MyArray[y-1][x] == 4) //if person above
				{
					PersonTryEscape(y-1,x,1);
					WaterMoved = true;
				}

				if (MyArray[y][x+1] == 4) //if person to the right
				{
					PersonTryEscape(y,x+1,4);
					WaterMoved = true;
				}

				if (MyArray[y][x-1] == 4) //if person to the left
				{
					PersonTryEscape(y,x-1,3);
					WaterMoved = true;
				}

				if (MyArray[y+1][x] == 0)
				{
					MyArray[y+1][x] = 3;
					WaterMoved = true;
				}

				if (MyArray[y-1][x] == 0)
				{
					MyArray[y-1][x] = 3;
					WaterMoved = true;
				}

				if (MyArray[y][x+1] == 0)
				{
					MyArray[y][x+1] = 3;
					WaterMoved = true;
				}

				if (MyArray[y][x-1] == 0)
				{
					MyArray[y][x-1] = 3;
					WaterMoved = true;
				}

			}

		}

	}


	for (int y = 0; y < 15; ++y)
	{

		for (int x = 0; x < 20; ++x)
		{

			if (MyArray[y][x] == 3)
			{
				MyArray[y][x] = 2;
			}

		}

	}

	if (WaterMoved == false)
	{

		GameHasWon = true;

	}

}

//-----------------------------------------------------------------------------
// Name: Render()
// Desc: Draws the scene
//-----------------------------------------------------------------------------
VOID Render()
{
    // Clear the backbuffer to a black color
    g_pd3dDevice->Clear( 0, NULL, D3DCLEAR_TARGET, D3DCOLOR_XRGB( 0, 0, 0 ), 1.0f, 0 );

    // Begin the scene
    if( SUCCEEDED( g_pd3dDevice->BeginScene() ) )
    {

		
		RECT srcRect;
		srcRect.top    = 0;
		srcRect.left   = 0;
		srcRect.bottom = 32;
		srcRect.right  = 32;

		RECT srcxRect;
		srcxRect.top    = 0;
		srcxRect.left   = 0;
		srcxRect.bottom = 16;
		srcxRect.right  = 16;

		RECT srcnumbersRect;
		srcnumbersRect.top = 0;
		srcnumbersRect.left = (32 * GameCurrentBlocks);
		srcnumbersRect.bottom = 32;
		srcnumbersRect.right = (32 * GameCurrentBlocks) + 32;

		RECT srcnewgameRect;
		srcnewgameRect.top = 0;
		srcnewgameRect.left = 0;
		srcnewgameRect.bottom = 64;
		srcnewgameRect.right = 320;

		RECT srcHudRect;
		srcHudRect.top    = 0;
		srcHudRect.left   = 0;
		srcHudRect.bottom = 64;
		srcHudRect.right  = 640;

		RECT srcretryRect;
		srcretryRect.top    = 0;
		srcretryRect.left   = 0;
		srcretryRect.bottom = 32;
		srcretryRect.right  = 128;

		RECT srcmenuRect;
		srcmenuRect.top    = 0;
		srcmenuRect.left   = 0;
		srcmenuRect.bottom = 50;
		srcmenuRect.right  = 128;

		RECT srcadviceRect;
		srcadviceRect.top    = 0;
		srcadviceRect.left   = 0;
		srcadviceRect.bottom = 352;
		srcadviceRect.right  = 512;

		RECT srctitleRect;
		srctitleRect.top    = 0;
		srctitleRect.left   = 0;
		srctitleRect.bottom = 524;
		srctitleRect.right  = 620;


		D3DXVECTOR3 vCenter( 0.0f, 0.0f, 0.0f );

		g_pGridSprite->Begin( D3DXSPRITE_ALPHABLEND );

		if (GameCurrentLevel > 0)
		{

			static float fAnimationTimer = 0.0f;
			fAnimationTimer += g_fElpasedTime;

			if( fAnimationTimer > 0.4f && GameWaterRunning == true)
			{

				CheckMovement();
				fAnimationTimer = 0.0f;

			}

			for (int y = 0; y < 15; ++y)
			{

				for (int x = 0; x < 20; ++x)
				{

					D3DXVECTOR3 vPosition( (32 * x), (32 * y), 0.0f );

					if (MyArray[y][x] == 0)
					{

						g_pGridSprite->Draw( g_pGridTexture, &srcRect, &vCenter, &vPosition, D3DCOLOR_COLORVALUE(1.0f,1.0f,1.0f,1.0f) );

					}
					else if (MyArray[y][x] == 1)
					{
						
						g_pGridSprite->Draw( g_pLandTexture, &srcRect, &vCenter, &vPosition, D3DCOLOR_COLORVALUE(1.0f,1.0f,1.0f,1.0f) );

					}
					else if (MyArray[y][x] == 2)
					{
						
						g_pGridSprite->Draw( g_pWaterTexture, &srcRect, &vCenter, &vPosition, D3DCOLOR_COLORVALUE(1.0f,1.0f,1.0f,1.0f));

					}
					else if (MyArray[y][x] == 4)
					{
						
						g_pGridSprite->Draw( g_pDudeTexture, &srcRect, &vCenter, &vPosition, D3DCOLOR_COLORVALUE(1.0f,1.0f,1.0f,1.0f) );

					}
					else if (MyArray[y][x] == 5)
					{
						
						g_pGridSprite->Draw( g_pGrateTexture, &srcRect, &vCenter, &vPosition, D3DCOLOR_COLORVALUE(1.0f,1.0f,1.0f,1.0f) );

					}
					else if (MyArray[y][x] == 6)
					{
						
						g_pGridSprite->Draw( g_pDudeTexture, &srcRect, &vCenter, &vPosition, D3DCOLOR_COLORVALUE(1.0f,1.0f,1.0f,1.0f) );

					}
					else if (MyArray[y][x] == 7)
					{
						
						g_pGridSprite->Draw( g_pCrateTexture, &srcRect, &vCenter, &vPosition, D3DCOLOR_COLORVALUE(1.0f,1.0f,1.0f,1.0f) );

					}

				}		

			}

			//start mouse render

			D3DXVECTOR3 vPosition( (32 * mousex), (32 * mousey), 0.0f );

			g_pGridSprite->Draw( g_pMouseTexture, &srcRect, &vCenter, &vPosition, D3DCOLOR_COLORVALUE(1.0f,1.0f,1.0f,1.0f) );

			//end mouse render

		}

		//start hud render
	
		D3DXVECTOR3 vPosition2 = D3DXVECTOR3( 0, 480, 0.0f );

		if (GameInMenu == false && GameHasLost == false && GameHasWon == false && GameWaterRunning == false)
		{

			g_pGridSprite->Draw( g_pHudBackTexture, &srcHudRect, &vCenter, &vPosition2, D3DCOLOR_COLORVALUE(1.0f,1.0f,1.0f,1.0f) );

			vPosition2 = D3DXVECTOR3( 32, 496, 0.0f );

			g_pGridSprite->Draw( g_pLandTexture, &srcRect, &vCenter, &vPosition2, D3DCOLOR_COLORVALUE(1.0f,1.0f,1.0f,1.0f) );

			vPosition2 = D3DXVECTOR3( 72, 512, 0.0f );

			g_pGridSprite->Draw( g_pXTexture, &srcxRect, &vCenter, &vPosition2, D3DCOLOR_COLORVALUE(1.0f,1.0f,1.0f,1.0f) );

			vPosition2 = D3DXVECTOR3( 92, 500, 0.0f );

			g_pGridSprite->Draw( g_pNumberTexture, &srcnumbersRect, &vCenter, &vPosition2, D3DCOLOR_COLORVALUE(1.0f,1.0f,1.0f,1.0f) );

			vPosition2 = D3DXVECTOR3( 502, 487, 0.0f );

			g_pGridSprite->Draw( g_pMenuTexture, &srcmenuRect, &vCenter, &vPosition2, D3DCOLOR_COLORVALUE(1.0f,1.0f,1.0f,1.0f) );

			vPosition2 = D3DXVECTOR3( 130, 496, 0.0f );

			g_pGridSprite->Draw( g_pResetTexture, &srcretryRect, &vCenter, &vPosition2, D3DCOLOR_COLORVALUE(1.0f,1.0f,1.0f,1.0f) );

			vPosition2 = D3DXVECTOR3( 268, 496, 0.0f );

			g_pGridSprite->Draw( g_pLaunchTexture, &srcretryRect, &vCenter, &vPosition2, D3DCOLOR_COLORVALUE(1.0f,1.0f,1.0f,1.0f) );


		}


		if (GameInMenu == true)
		{

			if (GameCurrentLevel > 0)
			{

				vPosition2 = D3DXVECTOR3( 160, 242, 0.0f );

				g_pGridSprite->Draw( g_pContinueTexture, &srcnewgameRect, &vCenter, &vPosition2, D3DCOLOR_XRGB( 255, 255, 255 ) );
		
			}
			else
			{

				vPosition2 = D3DXVECTOR3( 10, 10, 0.0f );

				g_pGridSprite->Draw( g_pTitleTexture, &srctitleRect, &vCenter, &vPosition2, D3DCOLOR_XRGB( 255, 255, 255 ) );



			}

			vPosition2 = D3DXVECTOR3( 160, 316, 0.0f );

			g_pGridSprite->Draw( g_pNewgameTexture, &srcnewgameRect, &vCenter, &vPosition2, D3DCOLOR_XRGB( 255, 255, 255 ) );

			vPosition2 = D3DXVECTOR3( 160, 390, 0.0f );

			g_pGridSprite->Draw( g_pExitgameTexture, &srcnewgameRect, &vCenter, &vPosition2, D3DCOLOR_XRGB( 255, 255, 255 ) );

		}

		if (GameHasLost == true)
		{

			vPosition2 = D3DXVECTOR3( 160, 242, 0.0f );

			g_pGridSprite->Draw( g_pFailureTexture, &srcnewgameRect, &vCenter, &vPosition2, D3DCOLOR_XRGB( 255, 255, 255 ) );

			vPosition2 = D3DXVECTOR3( 256, 316, 0.0f );

			g_pGridSprite->Draw( g_pRetryTexture, &srcretryRect, &vCenter, &vPosition2, D3DCOLOR_XRGB( 255, 255, 255 ) );

		}

		if (GameHasWon == true)
		{

			if (GameCurrentLevel == 7)
			{

				vPosition2 = D3DXVECTOR3( 64, 64, 0.0f );

				g_pGridSprite->Draw( g_pEndgameTexture, &srcadviceRect, &vCenter, &vPosition2, D3DCOLOR_XRGB( 255, 255, 255 ) );

			}
			else
			{
				vPosition2 = D3DXVECTOR3( 160, 242, 0.0f );

				g_pGridSprite->Draw( g_pVictoryTexture, &srcnewgameRect, &vCenter, &vPosition2, D3DCOLOR_XRGB( 255, 255, 255 ) );

				vPosition2 = D3DXVECTOR3( 256, 316, 0.0f );

				g_pGridSprite->Draw( g_pNextTexture, &srcretryRect, &vCenter, &vPosition2, D3DCOLOR_XRGB( 255, 255, 255 ) );
			}

		}

		if (GameInTutorial == true)
		{

			if (GameCurrentLevel == 1)
			{

				vPosition2 = D3DXVECTOR3( 64, 64, 0.0f );

				g_pGridSprite->Draw( g_pAdvice1Texture, &srcadviceRect, &vCenter, &vPosition2, D3DCOLOR_XRGB( 255, 255, 255 ) );

			}
			else if (GameCurrentLevel == 2)
			{

				vPosition2 = D3DXVECTOR3( 64, 64, 0.0f );

				g_pGridSprite->Draw( g_pAdvice2Texture, &srcadviceRect, &vCenter, &vPosition2, D3DCOLOR_XRGB( 255, 255, 255 ) );


			}
			else if (GameCurrentLevel == 3)
			{

				vPosition2 = D3DXVECTOR3( 64, 64, 0.0f );

				g_pGridSprite->Draw( g_pAdvice3Texture, &srcadviceRect, &vCenter, &vPosition2, D3DCOLOR_XRGB( 255, 255, 255 ) );


			}
			else
			{

				GameInTutorial = false;

			}


		}

		//end hud render

		g_pGridSprite->End();

		// End the scene
		g_pd3dDevice->EndScene();


    }

    // Present the backbuffer contents to the display
    g_pd3dDevice->Present( NULL, NULL, NULL, NULL );
}




//-----------------------------------------------------------------------------
// Name: MsgProc()
// Desc: The window's message handler
//-----------------------------------------------------------------------------
LRESULT WINAPI MsgProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam )
{
    switch( msg )
    {
        case WM_DESTROY:
            Cleanup();
            PostQuitMessage( 0 );
            return 0;

		case WM_LBUTTONUP:
		{

			if (GameInMenu == false && GameHasLost == false && GameHasWon == false && GameInTutorial == false)
			{

				if (GameWaterRunning == false)
				{

					ptCurrentMousePosit.x = LOWORD (lParam);
					ptCurrentMousePosit.y = HIWORD (lParam);

					if ( ptCurrentMousePosit.x >= 502 && ptCurrentMousePosit.x <= 630) //if over Menu button
					{

						if ( ptCurrentMousePosit.y >= 487 && ptCurrentMousePosit.y <= 537)
						{

							GameInMenu = true;

						}

					}

					if ( ptCurrentMousePosit.x >= 130 && ptCurrentMousePosit.x <= 258) //if over reset button
					{

						if ( ptCurrentMousePosit.y >= 496 && ptCurrentMousePosit.y <= 528)
						{

							for (int y = 0; y < 15; ++y)
							{

								for (int x = 0; x < 20; ++x)
								{
									
									if (GameCurrentLevel == 1)
									{
										MyArray[y][x] = Level1[y][x];
									}
									else if (GameCurrentLevel == 2)
									{
										MyArray[y][x] = Level2[y][x];
									}
									else if (GameCurrentLevel == 3)
									{
										MyArray[y][x] = Level3[y][x];
									}
									else if (GameCurrentLevel == 4)
									{
										MyArray[y][x] = Level4[y][x];
									}
									else if (GameCurrentLevel == 5)
									{
										MyArray[y][x] = Level5[y][x];
									}
									else if (GameCurrentLevel == 6)
									{
										MyArray[y][x] = Level6[y][x];
									}
									else if (GameCurrentLevel == 7)
									{
										MyArray[y][x] = Level7[y][x];
									}



								}

							}

							GameCurrentBlocks = GameLandBlocks[GameCurrentLevel-1];	

						}

					}

					if ( ptCurrentMousePosit.x >= 268 && ptCurrentMousePosit.x <= 396) //if over reset button
					{

						if ( ptCurrentMousePosit.y >= 496 && ptCurrentMousePosit.y <= 528)
						{

							GameWaterRunning = true;

						}


					}

					if (GameCurrentBlocks > 0)
					{

						if (MyArray[mousey][mousex] == 0)
						{
						
							MyArray[mousey][mousex] = 1;
							--GameCurrentBlocks;

						}

					}

				}

			}
			else if (GameInMenu == true)
			{

				ptCurrentMousePosit.x = LOWORD (lParam);
				ptCurrentMousePosit.y = HIWORD (lParam);

				if ( ptCurrentMousePosit.x >= 160 && ptCurrentMousePosit.x <= 480) //if over NEW GAME button
				{

					if ( ptCurrentMousePosit.y >= 316 && ptCurrentMousePosit.y <= 380)
					{

						GameInMenu = false;

						for (int y = 0; y < 15; ++y)
						{

							for (int x = 0; x < 20; ++x)
							{

								MyArray[y][x] = Level1[y][x];

							}

						}

						GameCurrentLevel = 1;
						GameCurrentBlocks = GameLandBlocks[GameCurrentLevel-1];
						GameInTutorial = true;

					}


				}


				if ( ptCurrentMousePosit.x >= 160 && ptCurrentMousePosit.x <= 480) //if over EXIT GAME button
				{

					if ( ptCurrentMousePosit.y >= 390 && ptCurrentMousePosit.y <= 454)
					{

						Cleanup();
						PostQuitMessage( 0 );
						return 0;

					}

				}


				if (GameCurrentLevel > 0)
				{

					if ( ptCurrentMousePosit.x >= 160 && ptCurrentMousePosit.x <= 480) //if over CONTINUE button
					{

						if ( ptCurrentMousePosit.y >= 242 && ptCurrentMousePosit.y <= 306)
						{

							GameInMenu = false;

						}

					}

				}


			}
			else if (GameHasLost == true)
			{

				ptCurrentMousePosit.x = LOWORD (lParam);
				ptCurrentMousePosit.y = HIWORD (lParam);

				if ( ptCurrentMousePosit.x >= 256 && ptCurrentMousePosit.x <= 384) //if over Retry button
				{

					if ( ptCurrentMousePosit.y >= 316 && ptCurrentMousePosit.y <= 348)
					{

						GameHasLost = false;

						for (int y = 0; y < 15; ++y)
						{

							for (int x = 0; x < 20; ++x)
							{
								
								if (GameCurrentLevel == 1)
								{
									MyArray[y][x] = Level1[y][x];
								}
								else if (GameCurrentLevel == 2)
								{
									MyArray[y][x] = Level2[y][x];
								}
								else if (GameCurrentLevel == 3)
								{
									MyArray[y][x] = Level3[y][x];
								}
								else if (GameCurrentLevel == 4)
								{
									MyArray[y][x] = Level4[y][x];
								}
								else if (GameCurrentLevel == 5)
								{
									MyArray[y][x] = Level5[y][x];
								}
								else if (GameCurrentLevel == 6)
								{
									MyArray[y][x] = Level6[y][x];
								}
								else if (GameCurrentLevel == 7)
								{
									MyArray[y][x] = Level7[y][x];
								}


							}

						}

						GameCurrentBlocks = GameLandBlocks[GameCurrentLevel-1];	

					}

				}

			}
			else if (GameHasWon == true)
			{

				ptCurrentMousePosit.x = LOWORD (lParam);
				ptCurrentMousePosit.y = HIWORD (lParam);

				if ( ptCurrentMousePosit.x >= 256 && ptCurrentMousePosit.x <= 384) //if over Next button
				{

					if ( ptCurrentMousePosit.y >= 316 && ptCurrentMousePosit.y <= 348)
					{

						++GameCurrentLevel;
						GameCurrentBlocks = GameLandBlocks[GameCurrentLevel-1];	
						GameHasWon = false;
						GameWaterRunning = false;
						GameInTutorial = true;

						for (int y = 0; y < 15; ++y)
						{

							for (int x = 0; x < 20; ++x)
							{
								
								if (GameCurrentLevel == 1)
								{
									MyArray[y][x] = Level1[y][x];
								}
								else if (GameCurrentLevel == 2)
								{
									MyArray[y][x] = Level2[y][x];
								}
								else if (GameCurrentLevel == 3)
								{
									MyArray[y][x] = Level3[y][x];
								}
								else if (GameCurrentLevel == 4)
								{
									MyArray[y][x] = Level4[y][x];
								}
								else if (GameCurrentLevel == 5)
								{
									MyArray[y][x] = Level5[y][x];
								}
								else if (GameCurrentLevel == 6)
								{
									MyArray[y][x] = Level6[y][x];
								}
								else if (GameCurrentLevel == 7)
								{
									MyArray[y][x] = Level7[y][x];
								}

							}

						}

					}


				}

			}

		}
		break;

		case WM_MOUSEMOVE:
		{

			if (GameInTutorial == false)
			{

				if (GameHasLost == false && GameInMenu == false)
				{

					ptCurrentMousePosit.x = LOWORD (lParam);
					ptCurrentMousePosit.y = HIWORD (lParam);

					for (int y = 0; y < 15; ++y)
					{

						for (int x = 0; x < 20; ++x)
						{

							if ( ptCurrentMousePosit.x > (x * 32) && ptCurrentMousePosit.x <= ((x * 32) +32))
							{

								if ( ptCurrentMousePosit.y > (y * 32) && ptCurrentMousePosit.y <= ((y * 32) +32))
								{

									mousex = x;
									mousey = y;

								}


							}


						}


					}

				}

			}

		}
		break;

		case WM_KEYDOWN:
		{

			switch( wParam )
			{
				case VK_SPACE:
				{

					if (GameInTutorial == true)
					{

						GameInTutorial = false;

					}
					else if (GameHasLost == false && GameInMenu == false && GameHasWon == false)
					{
						GameWaterRunning = true;
					}
				}
				break;

			}

		}
		break;

    }

    return DefWindowProc( hWnd, msg, wParam, lParam );
}




//-----------------------------------------------------------------------------
// Name: WinMain()
// Desc: The application's entry point
//-----------------------------------------------------------------------------
INT WINAPI wWinMain( HINSTANCE hInst, HINSTANCE, LPWSTR, INT )
{
    // Register the window class
    WNDCLASSEX wc =
    {
        sizeof( WNDCLASSEX ), CS_CLASSDC, MsgProc, 0L, 0L,
        GetModuleHandle( NULL ), NULL, NULL, NULL, NULL,
        "LD17 Game", NULL
    };
    RegisterClassEx( &wc );

    // Create the application's window
    HWND hWnd = CreateWindow( "LD17 Game", "LD17 - Island Construction Malfunction - Benn Powell",
                              WS_OVERLAPPEDWINDOW, 100, 100, 656, 582,
                              NULL, NULL, wc.hInstance, NULL ); //without bottom bar its 518

	PlaySound("music.wav",NULL,SND_FILENAME|SND_LOOP|SND_ASYNC); 

    // Initialize Direct3D
    if( SUCCEEDED( InitD3D( hWnd ) ) )
    {
        // Create the scene geometry
        if( SUCCEEDED( InitGeometry() ) )
        {
            // Show the window
            ShowWindow( hWnd, SW_SHOWDEFAULT );
            UpdateWindow( hWnd );

            // Enter the message loop
            MSG msg;
            ZeroMemory( &msg, sizeof( msg ) );
            while( msg.message != WM_QUIT )
            {
                if( PeekMessage( &msg, NULL, 0U, 0U, PM_REMOVE ) )
                {
                    TranslateMessage( &msg );
                    DispatchMessage( &msg );
                }
                else
				{
					g_dCurTime     = timeGetTime();
					g_fElpasedTime = (float)((g_dCurTime - g_dLastTime) * 0.001);
					g_dLastTime    = g_dCurTime;
                    Render();
				}
            }
        }
    }

    UnregisterClass( "LD17 Game", wc.hInstance );
    return 0;
}